#!/bin/sh
# [--- --  -   -                                                             ]
# [ Program Name: glFtpD Installer                                           ]
# [ Program  Ver: 1.08                                                       ]
# [ Purpose:      To install glFtpD                                          ]
# [ Dependancies: glFtpD Dist. available from http://glftpd.deepwell.com     ]
# [ Notes:        none                                                       ]
# [ Installation: cd into the untarred directory, then run sh ./glinstall.sh ]
# [                                                             -   -  -- ---]
# [--- --  -   -                                                             ]
# [ CHANGELOG                                                                ]
# [------                                                                    ]
# [ v1.08 - ROMRacer                                                         ]
# [  * fixed lib copy code, again.                                           ]
# [  * brought it a little closer to full BSD compat                         ]
# [------                                                                    ]
# [ v1.07 - ROMRacer                                                         ]
# [  * modified lib copy code.  detects bsd now.                             ]
# [  * cleaned up the code                                                   ]
# [------                                                                    ]
# [ v1.06 - ROMRacer                                                         ]
# [  + added dir selection                                                   ]
# [  * fixed error code problems.. could be run as part of another install   ]
# [    exit 1 = failure; exit 0 = all is good                                ]
# [  * modified lib copy code.. might break bsd compat.. let me know         ]
# [  * fixed more tcpd code                                                  ]
# [  * modified some bin calling code.. if compat breaks let me know         ]
# [------                                                                    ]
# [ v1.05 and below                                                          ]
# [  + BSD Detection and tcpd fixed by JabberA                               ]
# [  + TCPD Fixed by inCIDent                                                ]
# [  + Major bugs fixed by VR_Dude                                           ]
# [------                                                                    ]
# [ Original design idea by Archimede                                        ]
# [                                                             -   -  -- ---]
ver="1.08"
progs="sh kill cat echo grep unzip ls bash wc"
clear
echo "[-----------------------------------------------]"
echo "[       glFtpD Installation script $ver         ]"
echo "[       --------------------------------        ]"
echo "[  This is a beta and may not work, please use  ]"
echo "[  at your own peril                            ]"
echo "[                    -ROMRacer/romracer@isos.net]"
echo "[-----------------------------------------------]"
echo 
echo -n " Doing Sanity Checks..."
if [ ! `whoami` = "root" ] ; then
  echo "failure"
  echo "root required to install glFtpD"
  exit 1
fi
if [ ! -r `pwd`/bin/glftpd ] ; then
  echo "failure"
  echo "cannot find glFtpD binary"
  exit 1
fi
if [ -x "/usr/libexec/tcpd" ] ; then
  TCPD=/usr/libexec/tcpd
elif [ -x "/usr/sbin/tcpd" ] ; then
  TCPD=/usr/sbin/tcpd
else
  usetcpd=0
fi
echo "done"

echo
echo "[- -                                          ]"
echo "[   Where would you like to install glFtpD?   ]"
echo "[                                          - -]"
echo -n "Directory [ie. /glftpd/]: "
read instdir
if [ -d $instdir ] ; then
  echo "Directory exists.."
  echo "Y ./. remove all files and install"
  echo "N ./. abort install"
  echo "WARNING: Y is permanent and irrevocable"
  read abort
  if [ $abort = "y" ] ; then
    abort="Y"
  fi
  if [ $abort = "Y" ] ; then
    `which rm` -Rf $instdir
  else
    echo
    echo "Install dir caused abort.."
    exit 1
  fi
fi

echo " [x] Installing glFtpD on "`uname -s`" Kernel "`uname -r`" on a "`uname -m`
echo " [x] Source Directory: "`pwd`
echo " [x] Installation Directory: $instdir"
echo
echo "[- - - -                               - - - - -]"
echo "[      Press return to start the Install        ]"
echo "[- - - -                               - - - - -]"
read $NULL

echo -n "Making Directory..."
if [ -d $instdir ]; then
  echo "failure"
  echo "Funky dir error.. email romracer@isos.net or find on iRC"
  exit 1
else
  `which mkdir` $instdir
  echo "done"
fi

echo -n "Moving distribution to $instdir..."
`which cp` -R * $instdir
echo "done"

echo -n "Making Psuedo Devices..."
cd $instdir/dev
`which mknod` -m666 null c 1 3
`which mknod` -m666 zero c 1 5
echo "done"

echo -n "Checking Binaries..."
for i in $progs; do 
  `which cp` `which $i` $instdir/bin
done
echo "done"

echo -n "Copying Libraries..."
if [ `uname -s | sed "s/.*BSD.*/BSD/"` = "BSD" ] ; then
  echo "failure"
  echo "BSD detected.  Copy your own libs..."
  bsd="1"
elif [ `uname -s | sed 's/.*bsd.*/BSD/'` = "BSD" ] ; then
  echo "failure"
  echo "BSD detected.  Copy your own libs..."
  bsd="1"
else
  bsd="0"
  ldd=`which ldd`
  grep=`which grep`
  sort=`which sort`
  uniq=`which uniq`
  tr=`which tr`
  cut=`which cut`
  for i in `$ldd /lib/* 2>/dev/null | $grep =\> | $sort | $uniq | $tr -s " " | $cut -f 3 -d " "` ; do
    `which cp` -f $i $instdir/lib
  done
  cd $instdir
  `which mkdir` usr/
  `which mkdir` usr/lib/
  for i in `$ldd /usr/lib/* 2>/dev/null | $grep =\> | $sort | $uniq | $tr -s " " | $cut -f 3 -d " "` ; do
    `which cp` -f $i $instdir/usr/lib
  done
  echo "done"
  echo "Its up to you to ensure the libs copied to $instdir/lib correctly.."
fi

echo -n "Configuring dependencies..."
if [ $bsd = "0" ] ; then
  if [ -x /sbin/ldconfig ] ; then
    `which cp` /sbin/ldconfig $instdir/bin
    `which chroot` $instdir /bin/ldconfig 2> /dev/null
    echo "done"
  elif [ -x /bin/ldconfig ] ; then
    `which cp` /bin/ldconfig $instdir/bin
    `which chroot` $instdir /bin/ldconfig 2> /dev/null
    echo "done"
  else
    echo "failure"
    echo "Can't find ldconfig.. Find it and copy it to $instdir/bin"
    echo "Then run chroot $instdir /bin/ldconfig"
  fi
else
  echo "failure"
  echo "You must ldconfig once you copy the binaries.  chroot $instdir /bin/ldconfig"
fi

echo -n "Setting permissions..."
`which chmod` -R 755 $instdir
`which chmod` -R 777 $instdir/site/
echo "done"

echo
echo
echo "[- - - -                      - - - - -]"
echo "[      Press return to continue        ]"
echo "[- - - -                      - - - - -]"
read $NULL

if [ ! -f /etc/glftpd.conf ]; then
  `which cp` $instdir/glftpd.conf-EXTREME /etc/glftpd.conf
fi

echo -n "Configuring inetd.conf..."
if `$grep ^glftpd /etc/inetd.conf > /dev/null`; then
  echo "failure"
  echo "inetd.conf entry already exists, skipping"
else 
  if [ ! usetcpd = 0 ] ; then
    echo "glftpd	stream	tcp	nowait	root	$TCPD	$instdir/bin/glftpd -l -o -i" >> /etc/inetd.conf
  else
    echo "glftpd	stream	tcp	nowait	root	$instdir/bin/glftpd	glftpd -l -o -i" >> /etc/inetd.conf
  fi
  echo "done"
fi

echo -n "Configuring Services..."
if `$grep ^glftpd /etc/services > /dev/null`; then
  echo "failure"
  echo "services entry already exists, skipping"
else   
  echo
  echo "[- -                                          ]"
  echo "[ What port would you like glFtpD to run on ? ]"
  echo "[                                          - -]"
  echo -n "Port: "
  read port
  echo "glftpd	$port/tcp" >> /etc/services
  echo "done"
fi

echo -n "Restarting Inetd..."
`which killall` -HUP inetd
echo "done"

echo
echo
echo "[-----------------------------------------------]"
echo "[       glFtpD Installation script $ver         ]"
echo "[       --------------------------------        ]"
echo "[                                               ]"
echo "[     glFtpD has been sucessfully installed.    ]"
echo "[      Please refer to glftpd.docs for help     ]"
echo "[                                               ]"
echo "[  You will now be presented with an editor to  ]"
echo "[   configure the glFtpD configuration file.    ]"
echo "[                                               ]"
echo "[   For more information about glFtpD, visit    ]"
echo "[  http://glftpd.deepwell.com or #glftpd@EFnet  ]"
echo "[                                               ]" 
echo "[                    -ROMRacer/romracer@isos.net]"
echo "[-----------------------------------------------]"
echo 
echo "[- - - -                               - - - - -]"
echo "[       Press return to start the editor        ]"
echo "[- - - -                               - - - - -]"
read $NULL
if [ ! -z $EDITOR ] ; then
  $EDITOR /etc/glftpd.conf
elif [ -x `which pico` ] ; then
  `which pico` /etc/glftpd.conf
elif [ -x `which joe` ] ; then
  `which joe` /etc/glftpd.conf
elif [ -x `which vi`] ; then
  `which vi` /etc/glftpd.conf
else
  echo
  echo "Could not find a usable file editor"
  echo "Please locate one yourself and edit /etc/glftpd.conf"
fi
